module ExitCodes where

import RIO

-- * Error during processing, might have left traces on the file system: bit 64 unset

-- ** Error during normal operation: bit 32 unset

-- *** Error when applying changes: bit 16 set

exitFailedParseChange :: Int
exitFailedParseChange = 17

-- ** Error druing setup: bit 32 set

exitFailedInitialParse :: Int
exitFailedInitialParse = 33

-- * Prerequisite errors, nothing done: bit 64 is set

-- ** Prerequisite error in local state: bit 32 unset

exitFailedToReadGlobalState :: Int
exitFailedToReadGlobalState = 65

exitAlreadyInit :: Int
exitAlreadyInit = 66

exitAlreadyPeers :: Int
exitAlreadyPeers = 67

exitMailRootPresent :: Int
exitMailRootPresent = 68

exitPeerKnown :: Int
exitPeerKnown = 69

-- ** Invocation errors, no part of the file system looked at: bit 32 set as well
exitFailedToParseCmdLine :: Int
exitFailedToParseCmdLine = 97

