module Lock.Sync
       ( withWriteLock
       , withMasterLock
       , SharedExclusive(..)
       )
where

import RIO
import RIO.Directory (doesFileExist)
import RIO.FilePath ((</>))

import IOClasses
import Lock


withMasterLock :: (HasMailSyncConfig env) => SharedExclusive -> RIO env a -> RIO env a
withMasterLock se x = do
  syncDir <- view mailSyncDirL
  let fp = syncDir </> "master.lock"
  unlessM (doesFileExist fp) $ writeFileUtf8 fp "For locking only"
  withLock fp se Block x

withWriteLock :: (HasMailSyncConfig env) => RIO env a -> RIO env a
withWriteLock = withMasterLock Exclusive
