module Purge ( purge
             , dropPeer
             ) where

import RIO

import qualified RIO.HashMap as H

import Data
import IOClasses
import IOData ( readPeerState
              , withGlobalStateLocked
              , writeGlobalState_
              )

import qualified LocalUpdates as LU
import qualified RemoteUpdates as RU

purge :: (HasMailSyncConfig env) => RIO env ()
purge = withGlobalStateLocked $ \gs -> do
  known <- forM (H.keys $ upstreamPeers gs) readPeerState
  writeGlobalState_ $ LU.purge known gs

dropPeer :: (HasMailSyncConfig env) => PeerId -> RIO env ()
dropPeer peer = withGlobalStateLocked $ \gs -> do
  let gs' = RU.dropPeer gs peer
  known <- forM (H.keys $ upstreamPeers gs') readPeerState
  writeGlobalState_ $ LU.purge known gs'
